#include "testlib.h"
#include <bits/stdc++.h>
using namespace std;

const int MAXN = 400000, MAXM = 400000;
int totn = 0, totm = 0;
int _t = 0;

string readAns(int n, int m, vector<array<int, 2>> edges, InStream& stream) { // Terminate if output is invalid or if subgraph is not an oddgraph.
    string answer = stream.readWord("YES|NO");
    if (answer == "NO") return answer;

    int k = stream.readInt(0, m);
    vector<array<int, 2>> sub_edges(k);
    vector<int> deg(n, 0);
    sort(edges.begin(), edges.end());

    for (int i = 0; i < k; i++) {
        int u = stream.readInt(1, n);
        int v = stream.readInt(1, n);
        u--;
        v--;
        if (u > v) swap(u, v);
        array<int, 2> e = {u, v};

        if (!binary_search(edges.begin(), edges.end(), e)) {
            quitf(_wa, "Edge not in given graph (test case %d)", _t);
        }

        sub_edges[i] = e;
        deg[u]++;
        deg[v]++;
    }

    sort(sub_edges.begin(), sub_edges.end());
    if (sub_edges.end() != unique(sub_edges.begin(), sub_edges.end())) {
        quitf(_wa, "Multi-edge found (test case %d)", _t);
    }

    for (auto d : deg) {
        if (!(d & 1)) {
            quitf(_wa, "Node of even degree found (test case %d)", _t);
        }
    }

    return answer;
}

void check() {
    // READ INPUT: Input is assumed to be valid.
    int n = inf.readInt();
    int m = inf.readInt();
    totn += n;
    totm += m;
    if (totn > MAXN) quitf(_fail, "Sum of n exceeds: %d, %d", totn, MAXN);
    if (totm > MAXM) quitf(_fail, "Sum of m exceeds: %d, %d", totm, MAXM);
    vector<array<int, 2>> edges;
    for (int i = 0; i < m; i++) {
        int u = inf.readInt(1, n);
        int v = inf.readInt(1, n);
        u--;
        v--;
        if (u > v) swap(u, v);
        edges.push_back({u, v});
    }

    string juryAnswer = readAns(n, m, edges, ans);
    string participantAnswer = readAns(n, m, edges, ouf);

    // VERDICT
    if (participantAnswer == juryAnswer) {
        return;
    }
    if (participantAnswer == "NO") {
        quitf(_wa, "Participant did not find the answer, whilst jury can (test case %d)", _t);
    }
    quitf(_fail, "REQUIRES INVESTIGATION: Participant was able to find an answer when jury cannot (test case %d)", _t);
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    int t = inf.readInt();
    while (t--) {
        _t++;
        check();
    }

    quitf(_ok, "All correct! (%d test cases)", _t);
}
