#include <bits/stdc++.h>
using namespace std;

void dfs(vector<vector<int>> &adj, vector<bool> &vis, vector<int> &siz, vector<vector<int>> &favor, int u) {
    vis[u] = true;
    siz[u] = 1;
    for (auto v : adj[u]) {
        if (!vis[v]) {
            dfs(adj, vis, siz, favor, v);
            favor[u].push_back(v);
            siz[u] += siz[v];
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> adj(n);

    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    string answer = "YES";
    vector<bool> vis(n, false);
    vector<int> siz(n);
    vector<vector<int>> st_adj(n); // spanning forest's adjacency list

    for (int root = 0; root < n; root++) {
        if (vis[root]) {
            continue;
        }
        dfs(adj, vis, siz, st_adj, root);
        if (siz[root] % 2 == 1) {
            answer = "NO";
            break;
        }
    }

    cout << answer << '\n';
    if (answer == "YES") {
        vector<array<int, 2>> sub_edges;
        for (int u = 0; u < n; u++) {
            for (auto v : st_adj[u]) {
                if (siz[v] % 2 == 1) {
                    sub_edges.push_back({ u, v });
                }
            }
        }

        cout << sub_edges.size() << '\n';
        for (auto e : sub_edges) {
            cout << e[0] + 1 << ' ' << e[1] + 1 << '\n';
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
